<template>
  <div id="main-header">
    <div class="header-box">
      <div class="logo-panel">
        <img src="@/assets/icon-128.png" class="h-logo" alt="LINCS logo" />
        <h1>{{ $t("Header.context_explorer") }}</h1>
      </div>
      <div class="settings-box">
        <button :class="{
          'language-switch': true,
          'language-button': true,
          'language-button-active': language == 'en',
        }"
        v-on:click="onLanguageUpdate('en')">EN</button>
        <button :class="{
          'language-switch': true,
          'language-button': true,
          'language-button-active': language == 'fr',
        }"
        v-on:click="onLanguageUpdate('fr')">FR</button>
        <span class="language-switch"> | </span>
        <button
          class="setting-link"
          id="settings-icon"
          aria-label="Settings"
          tabindex="0"
          v-on:click="$router.push('/settings')"
        >
          <img class="s-icon" src="@/assets/settings.svg" alt="Settings" />
      </button>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-explicit-any */
import { Vue } from "vue-class-component";

export default class Header extends Vue {
  settings = null;
  language = '';

  mounted() {
    chrome.runtime.sendMessage({ type: "get-settings" }, (response) => {
      if (response) {
        this.settings = response.activeSettings ?? {};
        this.language = (this.settings as any).hidden.settings.languageSelection.value ? 'en' : 'fr';
      }
    });
  }

  onLanguageUpdate(locale: string) {
    this.$i18n.locale = locale;
    this.language = locale;

    if (this.settings) {
      (this.settings as any).hidden.settings.languageSelection.value = locale == 'en';
      chrome.runtime.sendMessage({
        type: "set-settings",
        settings: this.settings,
      });
    }
  }
}
</script>
<style></style>
